## qmmp 2.3.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.18.0 FATAL_ERROR)
project(qmmp)

#freebsd support
if(${CMAKE_SYSTEM_NAME} MATCHES "FreeBSD")
    include_directories(SYSTEM /usr/local/include)
    link_directories(AFTER /usr/local/lib)
    set(CMAKE_REQUIRED_INCLUDES ${CMAKE_REQUIRED_INCLUDES} /usr/local/include)
endif()

#macports support
if(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
    set(CMAKE_REQUIRED_INCLUDES ${CMAKE_REQUIRED_INCLUDES} /opt/local/include)
endif()

if(POLICY CMP0071)
  cmake_policy(SET CMP0071 NEW)
endif()

if(POLICY CMP0063)
    cmake_policy(SET CMP0063 NEW)
endif()

if(POLICY CMP0175)
    cmake_policy(SET CMP0175 NEW)
endif()

#Qt6 modules
set(CMAKE_PREFIX_PATH ${CMAKE_PREFIX_PATH} /home/user/qt6)

#installation paths
include(GNUInstallDirs)
include(FindPkgConfig)

#extract version from qmmp.h
file(STRINGS "${CMAKE_CURRENT_SOURCE_DIR}/src/qmmp/qmmp.h"
     QMMP_VERSION_DATA REGEX "^#define[ \t]+QMMP_VERSION_[A-Z]+[ \t]+[0-9]+.*$")

if(QMMP_VERSION_DATA)
    foreach(item IN ITEMS MAJOR MINOR PATCH STABLE)
        string(REGEX REPLACE ".*#define[ \t]+QMMP_VERSION_${item}[ \t]+([0-9]+).*"
        "\\1" QMMP_VERSION_${item} ${QMMP_VERSION_DATA})
    endforeach(item IN ITEMS MAJOR MINOR PATCH)

    set(QMMP_VERSION "${QMMP_VERSION_MAJOR}.${QMMP_VERSION_MINOR}.${QMMP_VERSION_PATCH}")
    set(QMMP_SOVERSION "${QMMP_VERSION_MAJOR}")

    if(QMMP_VERSION_STABLE)
       message(STATUS "Qmmp API version: ${QMMP_VERSION} (stable)")
    else(QMMP_VERSION_STABLE)
       message(STATUS "Qmmp API version: ${QMMP_VERSION} (development)")
    endif(QMMP_VERSION_STABLE)
else(QMMP_VERSION_DATA)
    message(FATAL_ERROR "invalid header")
endif(QMMP_VERSION_DATA)

configure_file(
  "${CMAKE_CURRENT_SOURCE_DIR}/cmake_uninstall.cmake.in"
  "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
  IMMEDIATE @ONLY)

add_custom_target(uninstall
  "${CMAKE_COMMAND}" -P "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake")

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_C_VISIBILITY_PRESET hidden)
set(CMAKE_CXX_VISIBILITY_PRESET hidden)
set(CMAKE_VISIBILITY_INLINES_HIDDEN 1)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_AUTOUIC ON)
set(CMAKE_INCLUDE_CURRENT_DIR ON)

add_definitions(-DQT_DISABLE_DEPRECATED_BEFORE=0x060200 -DQT_DEPRECATED_WARNINGS -DQT_MESSAGELOGCONTEXT)
add_compile_options(-Wall -Wextra)
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/src) #libqmmp & libqmmpui

find_package(Qt6 6.2 CONFIG REQUIRED COMPONENTS Widgets LinguistTools Network)
find_package(Qt6 6.2 CONFIG OPTIONAL_COMPONENTS DBus OpenGLWidgets Sql Multimedia)

get_target_property(QT_LRELEASE_EXECUTABLE Qt6::lrelease IMPORTED_LOCATION)

if(QT_LRELEASE_EXECUTABLE)
    message(STATUS "Found lrelease executable: " ${QT_LRELEASE_EXECUTABLE})
else(QT_LRELEASE_EXECUTABLE)
    message(FATAL_ERROR "Could NOT find lrelease executable")
endif(QT_LRELEASE_EXECUTABLE)

message(STATUS "Generating translations ...")

if(SVN_VERSION)
    execute_process(COMMAND find ${CMAKE_CURRENT_SOURCE_DIR} -name *.ts COMMAND xargs ${QT_LRELEASE_EXECUTABLE} -silent -nounfinished)
else(SVN_VERSION)
    execute_process(COMMAND find ${CMAKE_CURRENT_SOURCE_DIR} -name *.ts COMMAND xargs ${QT_LRELEASE_EXECUTABLE} -silent)
endif(SVN_VERSION)

set(PLUGIN_DIR "${CMAKE_INSTALL_LIBDIR}/qmmp-${QMMP_VERSION_MAJOR}.${QMMP_VERSION_MINOR}" CACHE STRING "plugin path")
option(USE_SKINNED "standard skinned user interface" ON)
option(USE_DIR_ASSOC "inode/directory mime type association" ON)
#set(APP_NAME_SUFFIX "-1")

get_target_property(QtGui_enabled_features Qt6::Gui QT_ENABLED_PUBLIC_FEATURES)
if("xcb" IN_LIST QtGui_enabled_features)
    pkg_search_module(X11 x11 IMPORTED_TARGET)
    set(XCB_ENABLED YES)
    add_definitions(-DQMMP_WS_X11)
endif()

if(X11_FOUND OR NOT XCB_ENABLED)
    set(SKINNED_AVAILABLE YES)
endif()

add_subdirectory(src/qmmp)
add_subdirectory(src/qmmpui)
add_subdirectory(src/plugins)
add_subdirectory(src/app)
add_subdirectory(doc)

if(MAD_FOUND)
    set(MPEG_DECODERS "MAD")
endif(MAD_FOUND)

if(MPG123_FOUND)
    set(MPEG_DECODERS ${MPEG_DECODERS} "mpg123")
endif(MPG123_FOUND)

if(XCB_FOUND OR WIN32)
    set(HOTKEY_AVAYLABLE YES)
endif()

macro(PRINT_SUMMARY str USE FOUND)
    if(${USE} AND ${FOUND})
        message("${str}enabled")
    else(${USE} AND ${FOUND})
        message("${str}disabled")
    endif(${USE} AND ${FOUND})
endmacro(PRINT_SUMMARY)


add_custom_target(distclean @echo cleaning for source distribution)

add_custom_command(
    POST_BUILD
    COMMENT "distribution clean"
    COMMAND ${CMAKE_MAKE_PROGRAM}
    ARGS -C ${CMAKE_CURRENT_BINARY_DIR} clean
    COMMAND find
    ARGS ${CMAKE_CURRENT_BINARY_DIR} -name "CMakeCache.txt" | xargs rm -rf
    COMMAND find
    ARGS ${CMAKE_CURRENT_BINARY_DIR} -name "CMakeFiles" | xargs rm -rf
    COMMAND find
    ARGS ${CMAKE_CURRENT_BINARY_DIR} -name "Makefile" | xargs rm -rf
    COMMAND find
    ARGS ${CMAKE_CURRENT_BINARY_DIR} -name \"*.cmake\" | xargs rm -rf
    COMMAND find
    ARGS ${CMAKE_CURRENT_SOURCE_DIR} -name "*.qm" | xargs rm -rf
    COMMAND find
    ARGS ${CMAKE_CURRENT_BINARY_DIR} -name "*.pc" | xargs rm -rf
    COMMAND find
    ARGS ${CMAKE_CURRENT_BINARY_DIR} -name "*.depends" | xargs rm -rf
    COMMAND find
    ARGS ${CMAKE_CURRENT_BINARY_DIR} -name "*.cxx_parameters" | xargs rm -rf
    COMMAND find
    ARGS ${CMAKE_CURRENT_BINARY_DIR} -name "moc_*.cpp" | xargs rm -rf
    COMMAND find
    ARGS ${CMAKE_CURRENT_BINARY_DIR} -name "qrc_*.cxx" | xargs rm -rf
    COMMAND find
    ARGS ${CMAKE_CURRENT_BINARY_DIR} -name "*_automoc.cpp" | xargs rm -rf
    COMMAND rm
    ARGS -rf ${CMAKE_CURRENT_BINARY_DIR}/install_manifest.txt
    COMMAND find
    ARGS ${CMAKE_CURRENT_BINARY_DIR} -name *_automoc.dir | xargs rm -rf
    COMMAND rm
    ARGS -rf ${CMAKE_CURRENT_BINARY_DIR}/doc/html .qt config.tests build.ninja .ninja_deps
    TARGET  distclean
)

message("")
message("Transports:")
PRINT_SUMMARY ("HTTP support .........................." USE_CURL CURL_FOUND)

message("")
message("Input Plugins:")
PRINT_SUMMARY ("MPEG support .........................." 1 MPEG_DECODERS)
PRINT_SUMMARY ("FLAC support .........................." USE_FLAC FLAC_FOUND)
PRINT_SUMMARY ("Ogg Vorbis support ...................." USE_VORBIS VORBIS_FOUND)
PRINT_SUMMARY ("Musepack support ......................" USE_MPC MPC_FOUND)
PRINT_SUMMARY ("MOD support ..........................." USE_XMP XMP_FOUND)
PRINT_SUMMARY ("Wave support .........................." USE_SNDFILE SNDFILE_FOUND)
PRINT_SUMMARY ("WavPack support ......................." USE_WAVPACK WAVPACK_FOUND)
PRINT_SUMMARY ("FFmpeg support ........................" USE_FFMPEG FFMPEG_FOUND)
PRINT_SUMMARY ("AAC support ..........................." USE_AAC FAAD_FOUND)
PRINT_SUMMARY ("CUE sheet support ....................." USE_CUE 1)
PRINT_SUMMARY ("CD Audio support ......................" USE_CDA CDIO_FOUND)
PRINT_SUMMARY ("Midi support .........................." USE_MIDI WILDMIDI_FOUND)
PRINT_SUMMARY ("Game music support ...................." USE_GME GME_FOUND)
PRINT_SUMMARY ("Ogg Opus support ......................" USE_OPUS OPUS_FOUND)
PRINT_SUMMARY ("SID support ..........................." USE_SID SIDPLAYFP_FOUND)
PRINT_SUMMARY ("Archive support ......................." USE_ARCHIVE LIBARCHIVE_FOUND)

message("")
message("Output Plugins:")
PRINT_SUMMARY ("ALSA support .........................." USE_ALSA ALSA_FOUND)
PRINT_SUMMARY ("OSS support ..........................." USE_OSS 1)
PRINT_SUMMARY ("OSS4 support .........................." USE_OSS4 OSS4_FOUND)
PRINT_SUMMARY ("JACK support .........................." USE_JACK JACK_FOUND)
PRINT_SUMMARY ("PulseAudio support ...................." USE_PULSE PULSE_FOUND)
PRINT_SUMMARY ("PipeWire support ......................" USE_PIPEWIRE PIPEWIRE_FOUND)
PRINT_SUMMARY ("Null output support ..................." USE_NULL 1)
PRINT_SUMMARY ("Waveout support (Windows) ............." USE_WAVEOUT WINDOWS_H_FOUND)
PRINT_SUMMARY ("DirectSound support (Windows) ........." USE_DSOUND DSOUND_H_FOUND)
PRINT_SUMMARY ("WASAPI support (Windows) .............." USE_WASAPI WASAPI_FOUND)
PRINT_SUMMARY ("Qt Multimedia support ................." USE_QTMULTIMEDIA Qt6Multimedia_FOUND)
PRINT_SUMMARY ("Icecast support ......................." USE_SHOUT SHOUT_FOUND)

message("")
message("Effect Plugins:")
PRINT_SUMMARY ("SoX Resampler ........................." USE_SOXR SOXR_FOUND)
PRINT_SUMMARY ("BS2B Plugin ..........................." USE_BS2B BS2B_FOUND)
PRINT_SUMMARY ("LADSPA Host ..........................." USE_LADSPA DLFCN_H_FOUND)
PRINT_SUMMARY ("Crossfade ............................." USE_CROSSFADE 1)
PRINT_SUMMARY ("Extra Stereo .........................." USE_STEREO 1)
PRINT_SUMMARY ("File Writer ..........................." USE_FILEWRITER VORBISENC_FOUND)
PRINT_SUMMARY ("Mono to Stereo Converter .............." USE_MONOTOSTEREO 1)

message("")
message("Visual Plugins:")
PRINT_SUMMARY ("Analyzer .............................." USE_ANALYZER 1)
PRINT_SUMMARY ("ProjectM .............................." USE_PROJECTM PROJECTM_FOUND)

message("")
message("General Plugins:")
PRINT_SUMMARY ("MPRIS support ........................." USE_MPRIS Qt6DBus_FOUND)
PRINT_SUMMARY ("Scrobbler ............................." USE_SCROBBLER 1)
PRINT_SUMMARY ("ListenBrainz .........................." USE_LISTENBRAINZ 1)
PRINT_SUMMARY ("Tray support .........................." USE_STATICON 1)
PRINT_SUMMARY ("Notifier support ......................" USE_NOTIFIER 1)
PRINT_SUMMARY ("Lyrics support ........................" USE_LYRICS 1)
PRINT_SUMMARY ("UDisks support ......,................." USE_UDISKS Qt6DBus_FOUND)
PRINT_SUMMARY ("Global hotkey support ................." USE_HOTKEY HOTKEY_AVAYLABLE)
PRINT_SUMMARY ("GNOME/Cinnamon hotkey support ........." USE_GNOMEHOTKEY Qt6DBus_FOUND)
PRINT_SUMMARY ("File operations ......................." USE_FILEOPS 1)
PRINT_SUMMARY ("Cover manager ........................." USE_COVER 1)
PRINT_SUMMARY ("KDE notifications support ............." USE_KDENOTIFY Qt6DBus_FOUND)
PRINT_SUMMARY ("Audio converter ......................." USE_CONVERTER TAGLIB_FOUND)
PRINT_SUMMARY ("ReplayGain Scanner ...................." USE_RGSCAN TAGLIB_FOUND)
PRINT_SUMMARY ("Stream browser ........................" USE_SB 1)
PRINT_SUMMARY ("Track change .........................." USE_TRACKCHANGE 1)
PRINT_SUMMARY ("Copy/Paste ............................" USE_COPYPASTE 1)
PRINT_SUMMARY ("History plugin ........................" USE_HISTORY Qt6Sql_FOUND)
PRINT_SUMMARY ("Sleep mode inhibition plugin .........." USE_SLEEPINHIBITOR Qt6DBus_FOUND)
PRINT_SUMMARY ("Media library plugin .................." USE_LIBRARY Qt6Sql_FOUND)
PRINT_SUMMARY ("Taskbar plugin (Windows) .............." USE_TASKBAR WIN32)
PRINT_SUMMARY ("Removable device detection (Windows) .." USE_RDETECT WIN32)

message("")
message("File Dialogs:")
PRINT_SUMMARY ("QMMP File Dialog ......................" USE_QMMP_DIALOG 1)
PRINT_SUMMARY ("Two-panel File File Dialog ............" USE_TWO_PANEL_DIALOG 1)

message("")
message("User Interfaces:")
PRINT_SUMMARY ("Skinned user interface ................" USE_SKINNED SKINNED_AVAILABLE)
PRINT_SUMMARY ("Simple user interface (QSUI) .........." USE_QSUI 1)

message("")
message("Advanced:")
PRINT_SUMMARY ("Automatic charset detection ..........." USE_ENCA ENCA_FOUND)
PRINT_SUMMARY ("MPEG plugin with LibRCD support ......." USE_LIBRCD LIBRCD_FOUND)
PRINT_SUMMARY ("CD Audio plugin with CDDB support ....." USE_LIBCDDB CDDB_FOUND)
PRINT_SUMMARY ("Directory association ................." USE_DIR_ASSOC 1)
PRINT_SUMMARY ("Set RPATH in installed binaries ......." CMAKE_INSTALL_RPATH_USE_LINK_PATH 1)
if(MPEG_DECODERS)
    message   ("MPEG decoders ........................." "${MPEG_DECODERS}")
endif(MPEG_DECODERS)

message("")

=== src/app/CMakeLists.txt ===
project(app)

set(app_SRCS
    builtincommandlineoption.cpp
    main.cpp
    qmmpstarter.cpp
    images/images.qrc
    translations/qmmp_locales.qrc
)

add_executable(qmmp ${app_SRCS})
target_link_libraries(qmmp PRIVATE Qt6::Widgets Qt6::Network libqmmp libqmmpui)
set_target_properties(qmmp PROPERTIES OUTPUT_NAME qmmp${APP_NAME_SUFFIX})

if(WIN32)
    target_sources(qmmp PRIVATE qmmp.rc)
    target_compile_definitions(qmmp PRIVATE QMMP_NO_CLI)
    set_target_properties(qmmp PROPERTIES WIN32_EXECUTABLE TRUE)    
    #cli version
    add_executable(qmmp-cli ${app_SRCS})
    target_link_libraries(qmmp-cli PRIVATE Qt6::Widgets Qt6::Network libqmmp libqmmpui)
    install(TARGETS qmmp-cli DESTINATION ${CMAKE_INSTALL_BINDIR})
endif(WIN32)

install(TARGETS qmmp DESTINATION ${CMAKE_INSTALL_BINDIR})
if(UNIX)
    install(FILES qmmp-opencda${APP_NAME_SUFFIX}.desktop DESTINATION ${CMAKE_INSTALL_DATADIR}/solid/actions)
    install(FILES qmmp${APP_NAME_SUFFIX}.desktop DESTINATION ${CMAKE_INSTALL_DATADIR}/applications)
    install(FILES images/16x16/qmmp${APP_NAME_SUFFIX}.png DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/16x16/apps)
    install(FILES images/32x32/qmmp${APP_NAME_SUFFIX}.png DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/32x32/apps)
    install(FILES images/48x48/qmmp${APP_NAME_SUFFIX}.png DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/48x48/apps)
    install(FILES images/56x56/qmmp${APP_NAME_SUFFIX}.png DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/56x56/apps)
    install(FILES images/64x64/qmmp${APP_NAME_SUFFIX}.png DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/64x64/apps)
    install(FILES images/128x128/qmmp${APP_NAME_SUFFIX}.png DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/128x128/apps)
    install(FILES images/256x256/qmmp${APP_NAME_SUFFIX}.png DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/256x256/apps)
    install(FILES images/scalable/qmmp${APP_NAME_SUFFIX}.svgz images/scalable/qmmp-simple${APP_NAME_SUFFIX}.svgz DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/scalable/apps)
    install(FILES metainfo/com.ylsoftware.qmmp${APP_NAME_SUFFIX}.metainfo.xml DESTINATION ${CMAKE_INSTALL_DATADIR}/metainfo)
endif(UNIX)

if(USE_DIR_ASSOC)
    install(FILES qmmp-enqueue${APP_NAME_SUFFIX}.desktop DESTINATION ${CMAKE_INSTALL_DATADIR}/applications)
    install(FILES qmmp-dir${APP_NAME_SUFFIX}.desktop DESTINATION ${CMAKE_INSTALL_DATADIR}/applications)
endif(USE_DIR_ASSOC)

=== src/plugins/CMakeLists.txt ===
option(USE_ENCA "libenca support" ON)
include(FindPkgConfig)
include(CheckIncludeFile)
pkg_search_module(ENCA enca>=1.9 IMPORTED_TARGET)
pkg_search_module(TAGLIB taglib>=1.12 IMPORTED_TARGET)

# disable "lib" prefix for plugins under Windows
if(WIN32)
    set(CMAKE_SHARED_MODULE_PREFIX "")
endif()

add_subdirectory(Input)
add_subdirectory(Output)
add_subdirectory(Visual)
add_subdirectory(Effect)
add_subdirectory(General)
add_subdirectory(PlayListFormats)
add_subdirectory(CommandLineOptions)
add_subdirectory(FileDialogs)
add_subdirectory(Transports)
add_subdirectory(Ui)

=== src/qmmp/CMakeLists.txt ===
project(libqmmp)

add_definitions(-DQMMP_LIBRARY)
set(libqmmp_DEFINES
    LIB_DIR="/${LIB_DIR}"
    QMMP_INSTALL_PREFIX="${CMAKE_INSTALL_PREFIX}"
    APP_NAME_SUFFIX="${APP_NAME_SUFFIX}"
)

if(NOT QMMP_VERSION_STABLE) #add svn revision
    execute_process(COMMAND sh ${CMAKE_CURRENT_SOURCE_DIR}/svn_revision.sh
                    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
                    OUTPUT_VARIABLE SVN_REVISION
                   OUTPUT_STRIP_TRAILING_WHITESPACE)
    if(SVN_REVISION)
        set(libqmmp_DEFINES ${libqmmp_DEFINES} SVN_REVISION="${SVN_REVISION}")
    endif(SVN_REVISION)
endif(NOT QMMP_VERSION_STABLE)

set(libqmmp_DEFINES ${libqmmp_DEFINES} QMMP_PLUGIN_DIR="${CMAKE_INSTALL_PREFIX}/${PLUGIN_DIR}")

set(QMMP_DEFAULT_OUTPUT "" CACHE STRING "default output plugin")
if(QMMP_DEFAULT_OUTPUT)
    SET(libqmmp_DEFINES ${libqmmp_DEFINES} QMMP_DEFAULT_OUTPUT="${QMMP_DEFAULT_OUTPUT}")
    MESSAGE(STATUS "Default output: ${QMMP_DEFAULT_OUTPUT}")
endif(QMMP_DEFAULT_OUTPUT)


set(libqmmp_SRCS
    visual.cpp
    recycler.cpp
    decoder.cpp
    output.cpp
    outputwriter.cpp
    trackinfo.cpp
    fft.c
    equ/iir.c
    equ/iir_cfs.c
    equ/iir_fpu.c
    soundcore.cpp
    effect.cpp
    qmmp.cpp
    statehandler.cpp
    volumehandler.cpp
    metadatamodel.cpp
    tagmodel.cpp
    qmmpaudioengine.cpp
    abstractengine.cpp
    audioparameters.cpp
    inputsource.cpp
    fileinputsource.cpp
    emptyinputsource.cpp
    metadatamanager.cpp
    replaygain.cpp
    qmmpsettings.cpp
    audioconverter.cpp
    eqsettings.cpp
    qmmpevents.cpp
    qmmpplugincache.cpp
    channelmap.cpp
    channelconverter.cpp
    volume.cpp
    dithering.cpp
    visualbuffer.cpp
    cueparser.cpp
    qmmptextcodec.cpp
)

SET(libqmmp_DEVEL_HDRS
    abstractengine.h
    audioconverter.h
    audioparameters.h
    buffer.h
    channelmap.h
    cueparser.h
    decoderfactory.h
    decoder.h
    effectfactory.h
    effect.h
    enginefactory.h
    eqsettings.h
    inputsourcefactory.h
    inputsource.h
    metadatamanager.h
    metadatamodel.h
    outputfactory.h
    output.h
    qmmp_export.h
    qmmp.h
    qmmpsettings.h
    qmmptextcodec.h
    soundcore.h
    statehandler.h
    tagmodel.h
    trackinfo.h
    visualfactory.h
    visual.h
    volume.h
    volumehandler.h
)

add_library(libqmmp SHARED ${libqmmp_SRCS})
target_link_libraries(libqmmp PRIVATE Qt6::Widgets)
set_target_properties(libqmmp PROPERTIES VERSION ${QMMP_VERSION} SOVERSION ${QMMP_SOVERSION} OUTPUT_NAME qmmp${APP_NAME_SUFFIX})
target_compile_definitions(libqmmp PRIVATE ${libqmmp_DEFINES})
install(TARGETS libqmmp LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
                        RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
                        ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR})

#freebsd support
if(${CMAKE_SYSTEM_NAME} MATCHES "FreeBSD")
    target_link_directories(libqmmp PRIVATE /usr/local/lib)
    target_link_libraries(libqmmp PRIVATE iconv)
endif()

if(APP_NAME_SUFFIX)
    install(FILES ${libqmmp_DEVEL_HDRS} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/qmmp${APP_NAME_SUFFIX}/qmmp)
    SET(QMMP_INCLUDE_DIR ${CMAKE_INSTALL_FULL_INCLUDEDIR}/qmmp${APP_NAME_SUFFIX})
else()
    install(FILES ${libqmmp_DEVEL_HDRS} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/qmmp)
    SET(QMMP_INCLUDE_DIR ${CMAKE_INSTALL_FULL_INCLUDEDIR})
endif()

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/qmmp.pc.in ${CMAKE_CURRENT_BINARY_DIR}/qmmp${APP_NAME_SUFFIX}.pc @ONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/qmmp${APP_NAME_SUFFIX}.pc DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)

=== src/qmmpui/CMakeLists.txt ===
project(libqmmpui)

add_definitions(-DQMMPUI_LIBRARY)

set(QMMP_DEFAULT_UI "" CACHE STRING "default user interface")
if(QMMP_DEFAULT_UI)
    set(libqmmpui_DEFINES ${libqmmpui_DEFINES} QMMP_DEFAULT_UI="${QMMP_DEFAULT_OUTPUT}")
    message(STATUS "Default user interface: ${QMMP_DEFAULT_UI}")
endif(QMMP_DEFAULT_UI)


set(libqmmpui_SRCS
    general.cpp
    uihelper.cpp
    playlistparser.cpp
    commandlinemanager.cpp
    commandlinehandler.cpp
    filedialog.cpp
    qtfiledialog.cpp
    fileloader.cpp
    playstate.cpp
    playlistmodel.cpp
    playlistitem.cpp
    playlistgroup.cpp
    playlisttrack.cpp
    playlistcontainer.cpp
    normalcontainer.cpp
    groupedcontainer.cpp
    mediaplayer.cpp
    detailsdialog.cpp
    tageditor.cpp
    playlistmanager.cpp
    metadataformatter.cpp
    metadataformattermenu.cpp
    templateeditor.cpp
    uiloader.cpp
    jumptotrackdialog.cpp
    configdialog.cpp
    pluginitem.cpp
    aboutdialog.cpp
    qmmpuisettings.cpp
    radioitemdelegate.cpp
    playlistdownloader.cpp
    addurldialog.cpp
    qmmpuiplugincache.cpp
    playlisttask.cpp
    playlistheadermodel.cpp
    columneditor.cpp
    metadatahelper.cpp
    coverviewer.cpp
    covereditor.cpp
    coverloader.cpp
    generalfactory.cpp
    cueeditor.cpp
    visualmenu.cpp
    colorwidget.cpp
    shortcutdialog.cpp
    forms/detailsdialog.ui
    forms/tageditor.ui
    forms/templateeditor.ui
    forms/jumptotrackdialog.ui
    forms/configdialog.ui
    forms/aboutdialog.ui
    forms/addurldialog.ui
    forms/columneditor.ui
    forms/covereditor.ui
    forms/cueeditor.ui
    forms/shortcutdialog.ui
    translations/libqmmpui_locales.qrc
    txt/txt.qrc
    images/qmmpui_images.qrc
)

SET(libqmmpui_DEVEL_HDRS
    colorwidget.h
    commandlinehandler.h
    commandlinemanager.h
    configdialog.h
    detailsdialog.h
    filedialogfactory.h
    filedialog.h
    generalfactory.h
    general.h
    mediaplayer.h
    metadataformatter.h
    metadataformattermenu.h
    playlistdownloader.h
    playlistformat.h
    playlistgroup.h
    playlistheadermodel.h
    playlistitem.h
    playlistmanager.h
    playlistmodel.h
    playlistparser.h
    playlisttrack.h
    qmmpui_export.h
    qmmpuisettings.h
    shortcutdialog.h
    templateeditor.h
    uifactory.h
    uihelper.h
    uiloader.h
    visualmenu.h
)

set(CMAKE_AUTOUIC_SEARCH_PATHS ${CMAKE_AUTOUIC_SEARCH_PATHS} ${CMAKE_CURRENT_SOURCE_DIR}/forms)

add_library(libqmmpui SHARED ${libqmmpui_SRCS})
target_link_libraries(libqmmpui PRIVATE Qt6::Widgets Qt6::Network libqmmp)
set_target_properties(libqmmpui PROPERTIES VERSION ${QMMP_VERSION} SOVERSION ${QMMP_SOVERSION} OUTPUT_NAME qmmpui${APP_NAME_SUFFIX})
target_compile_definitions(libqmmpui PRIVATE ${libqmmpui_DEFINES})
install(TARGETS libqmmpui LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
                          RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
                          ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR})


if(APP_NAME_SUFFIX)
    install(FILES ${libqmmpui_DEVEL_HDRS} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/qmmp${APP_NAME_SUFFIX}/qmmpui)
    set(QMMP_INCLUDE_DIR ${CMAKE_INSTALL_FULL_INCLUDEDIR}/qmmp${APP_NAME_SUFFIX})
else()
    install(FILES ${libqmmpui_DEVEL_HDRS} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/qmmpui)
    set(QMMP_INCLUDE_DIR ${CMAKE_INSTALL_FULL_INCLUDEDIR})
endif()

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/qmmpui.pc.in ${CMAKE_CURRENT_BINARY_DIR}/qmmpui${APP_NAME_SUFFIX}.pc @ONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/qmmpui${APP_NAME_SUFFIX}.pc DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)

=== src/plugins/FileDialogs/CMakeLists.txt ===
option(USE_QMMP_DIALOG "Qmmp file dialog" ON)
option(USE_TWO_PANEL_DIALOG "Two-panel file dialog" ON)

if(USE_QMMP_DIALOG)
    add_subdirectory(QmmpFileDialog)
endif(USE_QMMP_DIALOG)

if(USE_TWO_PANEL_DIALOG)
    add_subdirectory(TwoPanelFileDialog)
endif(USE_TWO_PANEL_DIALOG)

=== src/plugins/General/CMakeLists.txt ===
option(USE_MPRIS          "mpris plugin" ON)
option(USE_SCROBBLER      "scrobbler plugin" ON)
option(USE_LISTENBRAINZ   "listenbrainz plugin" ON)
option(USE_STATICON       "status icon plugin" ON)
option(USE_NOTIFIER       "notifier plugin" ON)
option(USE_LYRICS         "lyrics version" ON)
option(USE_UDISKS         "udisks plugin" ON)
option(USE_HOTKEY         "global hotkey plugin" ON)
option(USE_GNOMEHOTKEY    "gnome hotkey plugin" ON)
option(USE_FILEOPS        "fileops plugin" ON)
option(USE_COVER          "cover manager plugin" ON)
option(USE_KDENOTIFY      "kde notification plugin" ON)
option(USE_CONVERTER      "audio converter plugin" ON)
option(USE_RGSCAN         "replaygain scanner plugin" ON)
option(USE_SB             "stream browser plugin" ON)
option(USE_TRACKCHANGE    "track change plugin" ON)
option(USE_COPYPASTE      "copy/paste change plugin" ON)
option(USE_HISTORY        "history plugin" ON)
option(USE_SLEEPINHIBITOR "sleep mode inhibition plugin" ON)
option(USE_LIBRARY        "media library plugin" ON)
option(USE_TASKBAR        "taskbar plugin (Windows)" ON)
option(USE_RDETECT        "rdetect plugin (Windows)" ON)

if(USE_MPRIS AND Qt6DBus_FOUND)
    add_subdirectory(mpris)
endif(USE_MPRIS AND Qt6DBus_FOUND)

if(USE_SCROBBLER)
    add_subdirectory(scrobbler)
endif(USE_SCROBBLER)

if(USE_LISTENBRAINZ)
    add_subdirectory(listenbrainz)
endif(USE_LISTENBRAINZ)

if(USE_STATICON)
    add_subdirectory(statusicon)
endif(USE_STATICON)

if(USE_NOTIFIER)
    add_subdirectory(notifier)
endif(USE_NOTIFIER)

if(USE_LYRICS)
    add_subdirectory(lyrics)
endif(USE_LYRICS)

if(USE_UDISKS AND Qt6DBus_FOUND)
    add_subdirectory(udisks)
endif(USE_UDISKS AND Qt6DBus_FOUND)

if(USE_HOTKEY AND (X11_FOUND OR WIN32))
    add_subdirectory(hotkey)
endif(USE_HOTKEY AND (X11_FOUND OR WIN32))

if(USE_FILEOPS)
    add_subdirectory(fileops)
endif(USE_FILEOPS)

if(USE_COVER)
    add_subdirectory(covermanager)
endif(USE_COVER)

if(USE_KDENOTIFY AND Qt6DBus_FOUND)
    add_subdirectory(kdenotify)
endif(USE_KDENOTIFY AND Qt6DBus_FOUND)

if(USE_CONVERTER AND TAGLIB_FOUND)
    add_subdirectory(converter)
endif(USE_CONVERTER AND TAGLIB_FOUND)

if(USE_RGSCAN AND TAGLIB_FOUND)
    add_subdirectory(rgscan)
endif(USE_RGSCAN AND TAGLIB_FOUND)

if(USE_SB)
    add_subdirectory(streambrowser)
endif(USE_SB)

if(USE_TRACKCHANGE)
    add_subdirectory(trackchange)
endif(USE_TRACKCHANGE)

if(USE_COPYPASTE)
    add_subdirectory(copypaste)
endif(USE_COPYPASTE)

if(USE_GNOMEHOTKEY AND Qt6DBus_FOUND)
    add_subdirectory(gnomehotkey)
endif(USE_GNOMEHOTKEY AND Qt6DBus_FOUND)

if(USE_HISTORY AND Qt6Sql_FOUND)
   add_subdirectory(history)
endif(USE_HISTORY AND Qt6Sql_FOUND)

if(USE_SLEEPINHIBITOR AND Qt6DBus_FOUND)
   add_subdirectory(sleepinhibitor)
endif(USE_SLEEPINHIBITOR AND Qt6DBus_FOUND)

if(USE_TASKBAR AND WIN32)
   add_subdirectory(taskbar)
endif(USE_TASKBAR AND WIN32)

if(USE_RDETECT AND WIN32)
   add_subdirectory(rdetect)
endif(USE_RDETECT AND WIN32)

if(USE_LIBRARY AND Qt6Sql_FOUND)
    add_subdirectory(library)
endif(USE_LIBRARY AND Qt6Sql_FOUND)

=== src/plugins/Input/CMakeLists.txt ===
option(USE_MAD     "mad decoder (mpeg plugin)" ON)
option(USE_MPG123  "mpg123 decoder (mpeg plugin)" ON)
option(USE_FLAC    "flac plugin" ON)
option(USE_VORBIS  "ogg vorbis plugin" ON)
option(USE_FFMPEG  "ffmpeg plugin" ON)
option(USE_MPC     "mpc plugin" ON)
option(USE_SNDFILE "sndfile plugin" ON)
option(USE_WAVPACK "wavpack plugin" ON)
option(USE_XMP     "xmp plugin" ON)
option(USE_AAC     "aac plugin" ON)
option(USE_CUE     "cue plugin" ON)
option(USE_CDA     "cd audio support" ON)
option(USE_MIDI    "midi support" ON)
option(USE_GME     "game music plugin" ON)
option(USE_OPUS    "opus plugin" ON)
option(USE_SID     "sid plugin" ON)
option(USE_ARCHIVE "archive plugin" ON)


if((USE_MAD OR USE_MPG123) AND TAGLIB_FOUND)
    add_subdirectory(mpeg)
endif((USE_MAD OR USE_MPG123) AND TAGLIB_FOUND)

if(USE_FLAC AND TAGLIB_FOUND)
    add_subdirectory(flac)
endif(USE_FLAC AND TAGLIB_FOUND)

if(USE_VORBIS AND TAGLIB_FOUND)
    add_subdirectory(vorbis)
endif(USE_VORBIS AND TAGLIB_FOUND)

if(USE_FFMPEG AND TAGLIB_FOUND)
    add_subdirectory(ffmpeg)
endif(USE_FFMPEG AND TAGLIB_FOUND)

if(USE_MPC AND TAGLIB_FOUND)
    add_subdirectory(mpc)
endif(USE_MPC AND TAGLIB_FOUND)

if(USE_SNDFILE AND TAGLIB_FOUND)
   add_subdirectory(sndfile)
endif(USE_SNDFILE AND TAGLIB_FOUND)

if(USE_WAVPACK)
    add_subdirectory(wavpack)
endif(USE_WAVPACK)

if(USE_XMP)
   add_subdirectory(xmp)
endif(USE_XMP)

if(USE_AAC AND TAGLIB_FOUND)
   add_subdirectory(aac)
endif(USE_AAC AND TAGLIB_FOUND)

if(USE_CUE)
add_subdirectory(cue)
endif(USE_CUE)

if(USE_CDA)
add_subdirectory(cdaudio)
endif(USE_CDA)

if(USE_MIDI)
add_subdirectory(wildmidi)
endif(USE_MIDI)

if(USE_GME)
    add_subdirectory(gme)
endif(USE_GME)

if(USE_OPUS AND TAGLIB_FOUND)
    add_subdirectory(opus)
endif(USE_OPUS AND TAGLIB_FOUND)

if(USE_SID)
    add_subdirectory(sid)
endif(USE_SID)

if(USE_ARCHIVE AND TAGLIB_FOUND)
    add_subdirectory(archive)
endif(USE_ARCHIVE AND TAGLIB_FOUND)

=== src/plugins/Output/CMakeLists.txt ===
option(USE_ALSA         "alsa plugin" ON)
option(USE_JACK         "jack plugin" ON)
option(USE_OSS          "oss plugin" OFF)
option(USE_OSS4         "oss4 plugin" ON)
option(USE_PULSE        "pulseaudio plugin" ON)
option(USE_PIPEWIRE     "pipewire plugin" ON)
option(USE_NULL         "null output plugin" ON)
option(USE_WAVEOUT      "Win32 waveout plugin" ON)
option(USE_DSOUND       "DirectSound plugin" ON)
option(USE_QTMULTIMEDIA "Qt Multimedia output plugin" ON)
option(USE_WASAPI       "WASAPI plugin" ON)
option(USE_SHOUT        "Icecast plugin" ON)

if(USE_ALSA)
    add_subdirectory(alsa)
endif(USE_ALSA)

if(USE_JACK)
    add_subdirectory(jack)
endif(USE_JACK)

if(USE_OSS)
    add_subdirectory(oss)
endif(USE_OSS)

if(USE_OSS4)
    add_subdirectory(oss4)
endif(USE_OSS4)

if(USE_PULSE)
    add_subdirectory(pulseaudio)
endif(USE_PULSE)

if(USE_PIPEWIRE)
    add_subdirectory(pipewire)
endif(USE_PIPEWIRE)

if(USE_NULL)
    add_subdirectory(null)
endif(USE_NULL)

if(USE_WAVEOUT)
    add_subdirectory(waveout)
endif(USE_WAVEOUT)

if(USE_DSOUND)
    add_subdirectory(directsound)
endif(USE_DSOUND)

if(USE_QTMULTIMEDIA AND Qt6Multimedia_FOUND)
    add_subdirectory(qtmultimedia)
endif(USE_QTMULTIMEDIA AND Qt6Multimedia_FOUND)

if(USE_WASAPI)
    add_subdirectory(wasapi)
endif(USE_WASAPI)

if(USE_SHOUT)
    add_subdirectory(shout)
endif(USE_SHOUT)

=== src/plugins/PlayListFormats/CMakeLists.txt ===
add_subdirectory(m3u)
add_subdirectory(pls)
add_subdirectory(xspf)

=== src/plugins/Ui/CMakeLists.txt ===
option(USE_SKINNED "skinned user interface" ON)
option(USE_QSUI    "simple user interface (qsui)" ON)

if(USE_SKINNED AND SKINNED_AVAILABLE)
    add_subdirectory(skinned)
endif(USE_SKINNED AND SKINNED_AVAILABLE)

if(USE_QSUI)
    add_subdirectory(qsui)
endif(USE_QSUI)

=== src/plugins/Visual/CMakeLists.txt ===
option(USE_ANALYZER "analyzer plugin" ON)
option(USE_PROJECTM "projectm plugin" ON)

if(USE_ANALYZER)
    add_subdirectory(analyzer)
endif(USE_ANALYZER)

if(USE_PROJECTM)
    add_subdirectory(projectm)
endif(USE_PROJECTM)

=== debian/changelog ===
qmmp (2.3.0-1) unstable; urgency=medium

  [ Harald Dunkel ]
  * new upstream version 2.3.0

  [ Matteo Cypriani ]
  * d/control: Updated dependencies & description
  * d/copyright: Removed refs to non-existent files
  * d/control: Dropped redundant Rules-Requires-Root
  * d/watch: Switched to format version 5

 -- Matteo Cypriani <mcy@lm7.fr>  Sat, 25 Oct 2025 15:56:00 +0200

=== debian/control ===
Source: qmmp
Section: sound
Priority: optional
Maintainer: Matteo Cypriani <mcy@lm7.fr>
Uploaders: Harald Dunkel <harri@afaics.de>
Build-Depends: debhelper-compat (= 13),
  cmake,
  libarchive-dev,
  libasound2-dev [linux-any],
  libavcodec-dev,
  libavformat-dev,
  libbs2b-dev,
  libcddb2-dev,
  libcdio-dev,
  libcdio-paranoia-dev,
  libcurl4-gnutls-dev,
  libenca-dev,
  libfaad-dev,
  libflac-dev,
  libgme-dev,
  libjack-jackd2-dev,
  libmad0-dev,
  libmpcdec-dev,
  libogg-dev,
  libopus-dev,
  libopusfile-dev,
  liboss4-salsa-dev [!linux-any],
  libpipewire-0.3-dev,
  libprojectm-dev [!armel !armhf !hurd-any],
  libpulse-dev,
  libqt6opengl6-dev,
  librcd-dev,
  libshout-dev,
  libsidplayfp-dev,
  libsndfile1-dev,
  libsoxr-dev,
  libtag-dev,
  libvorbis-dev,
  libwavpack-dev,
  libwildmidi-dev,
  libx11-dev,
  libxmp-dev,
  pkgconf,
  qt6-base-dev,
  qt6-multimedia-dev,
  qt6-tools-dev,
Standards-Version: 4.7.2
Homepage: https://qmmp.ylsoftware.com/
Vcs-Git: https://salsa.debian.org/debian/qmmp.git
Vcs-Browser: https://salsa.debian.org/debian/qmmp

Package: qmmp
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: qmmp-plugin-projectm, ffmpeg, unzip, udisks2 [linux-any]
Recommends: freepats
Replaces: libqmmp0 (<< 0.8), libqmmpui0 (<< 0.8), libqmmp-misc (<< 0.8)
Breaks: libqmmp0 (<< 0.8), libqmmpui0 (<< 0.8), libqmmp-misc (<< 0.8)
Description: feature-rich audio player with support of many formats
 Qmmp is feature-rich audio player with support of many formats.
 It is written in Qt.
 .
 Supported formats:
  - MPEG1 layer 2/3
  - Ogg Vorbis
  - Ogg Opus
  - Native FLAC, Ogg FLAC
  - Musepack
  - WavePack
  - tracker modules (mod, s3m, it, xm, etc)
  - ADTS AAC
  - CD Audio
  - WMA, Monkey's Audio (and other formats provided by FFmpeg library)
  - PCM WAVE (and other formats provided by libsndfile library)
  - midi
  - SID
  - chiptune formats (AY, GBS, GYM, HES, KSS, NSF, NSFE, SAP, SPC, VGM, VGZ,
    VTX)
 .
 DSP effects:
  - BS2B effect
  - sample rate converter
  - LADSPA effects
  - extra stereo
  - crossfade
 .
 Visual effects:
  - projectM visualization
  - spectrum analyzer
 .
 Audio output through:
  - ALSA
  - OSS
  - Pulse Audio
  - PipeWire
  - JACK
  - QTMultimedia
  - Icecast
 .
 Other features:
  - XMMS and Winamp 2.x skins support
  - alternative user interface based on standard widgets set
  - 10-band equalizer
  - MP3, Vorbis, AAC, AAC+ streams support
  - MPRIS
  - removable device detection (via UDisks)
  - lyrics
  - cover art support
  - CUE sheet support
  - embedded CUE support (for FLAC, WavPack and Monkey's Audio)
  - multiple playlists
  - automatic charset detection for cue files and ShoutCast metadata
  - playlist formats: m3u, pls, xspf
  - ReplayGain support
  - sending listening history to Last.fm, Libre.fm and ListenBrainz
  - CDDB support
  - stream browser
  - audio formats converter
  - external programs execution on track change
  - ReplayGain scanner
  - archive reader (RAR and 7z)
  - audio recording
  - listening history
  - media library

Package: qmmp-plugin-projectm
Architecture: any-amd64 any-arm64 i386 any-mips64el any-mipsel any-ppc64el any-s390x any-alpha any-hppa any-ia64 kfreebsd-any any-m68k any-powerpc any-ppc64 any-riscv64 any-sh4 any-sparc64 any-x32
Depends: ${misc:Depends}, ${shlibs:Depends}, fonts-dejavu-core
Description: qmmp audio player -- projectM visualization plugin
 Qmmp is feature-rich audio player with support of many formats.
 It is written in Qt.
 .
 See 'qmmp' package for full description.
 .
 This package contains projectM visualization plugin for qmmp.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1
#export DH_OPTIONS=-v

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

DEB_HOST_ARCH_OS ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)

ifeq ($(DEB_HOST_ARCH_OS),linux)
	EXTRA_CMAKE_ARGS = -DUSE_OSS4:BOOL=FALSE
else
	EXTRA_CMAKE_ARGS = -DUSE_ALSA:BOOL=FALSE -DUSE_PIPEWIRE:BOOL=FALSE -DUSE_UDISKS:BOOL=FALSE
endif

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_INSTALL_PREFIX=/usr \
	  -DCMAKE_INSTALL_LIBDIR=lib/qmmp \
	  -DPLUGIN_DIR=lib/qmmp/plugins \
	  -DCMAKE_INSTALL_RPATH=/usr/lib/qmmp \
	  -DCMAKE_BUILD_WITH_INSTALL_RPATH:BOOL=TRUE \
	  $(EXTRA_CMAKE_ARGS)

override_dh_auto_build:
	dh_auto_build -- VERBOSE=1

override_dh_install:
ifneq (,$(filter-out armel armhf,$(DEB_HOST_ARCH)))
	dh_install -pqmmp-plugin-projectm
endif
	chmod +x debian/tmp/usr/share/qmmp/scripts/kwin.sh
	chmod +x debian/tmp/usr/share/qmmp/scripts/kwin6.sh
	dh_install -Xprojectm

# Avoid a call to ldconfig in postinst & postrm (ldconfig is not needed since we
# only install private libraries)
override_dh_makeshlibs:
	dh_makeshlibs --noscripts

# dh_auto_clean doesn't call make distclean automatically from the CMake build
# directory, so we have to remove leftover .qm files manually
override_dh_auto_clean:
	find -name '*.qm' | xargs rm -fv
	rm -f debian/files
	dh_auto_clean

=== debian/watch ===
Version: 5
Source: https://qmmp.ylsoftware.com/files/@PACKAGE@/@ANY_VERSION@/
Matching-Pattern: @PACKAGE@@ANY_VERSION@@ARCHIVE_EXT@

## qmmp 2.3.1

=== debian/changelog ===
qmmp (2.3.1-1~mx25+1) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Thu, 19 Feb 2026 08:28:36 -0800

qmmp (2.3.1-1) unstable; urgency=medium

  [ Harald Dunkel ]
  * new upstream version 2.3.1

  [ Matteo Cypriani ]
  * d/control: Bump Standards-Version to 4.7.3
    + Dropped now optional Priority field
  * d/copyright: Bump debian/* to 2026

 -- Matteo Cypriani <mcy@lm7.fr>  Sat, 17 Jan 2026 17:09:29 +0100

=== debian/control ===
--- 
+++ 
@@ -1,50 +1,51 @@
 Source: qmmp
 Section: sound
 Priority: optional
-Maintainer: Matteo Cypriani <mcy@lm7.fr>
+Maintainer: Steven Pusser <stevep@mxlinux.org>
+XSBC-Original-Maintainer: Matteo Cypriani <mcy@lm7.fr>
 Uploaders: Harald Dunkel <harri@afaics.de>
 Build-Depends: debhelper-compat (= 13),
-  cmake,
-  libarchive-dev,
-  libasound2-dev [linux-any],
-  libavcodec-dev,
-  libavformat-dev,
-  libbs2b-dev,
-  libcddb2-dev,
-  libcdio-dev,
-  libcdio-paranoia-dev,
-  libcurl4-gnutls-dev,
-  libenca-dev,
-  libfaad-dev,
-  libflac-dev,
-  libgme-dev,
-  libjack-jackd2-dev,
-  libmad0-dev,
-  libmpcdec-dev,
-  libogg-dev,
-  libopus-dev,
-  libopusfile-dev,
-  liboss4-salsa-dev [!linux-any],
-  libpipewire-0.3-dev,
-  libprojectm-dev [!armel !armhf !hurd-any],
-  libpulse-dev,
-  libqt6opengl6-dev,
-  librcd-dev,
-  libshout-dev,
-  libsidplayfp-dev,
-  libsndfile1-dev,
-  libsoxr-dev,
-  libtag-dev,
-  libvorbis-dev,
-  libwavpack-dev,
-  libwildmidi-dev,
-  libx11-dev,
-  libxmp-dev,
-  pkgconf,
-  qt6-base-dev,
-  qt6-multimedia-dev,
-  qt6-tools-dev,
-Standards-Version: 4.7.2
+               cmake,
+               libarchive-dev,
+               libasound2-dev [linux-any],
+               libavcodec-dev,
+               libavformat-dev,
+               libbs2b-dev,
+               libcddb2-dev,
+               libcdio-dev,
+               libcdio-paranoia-dev,
+               libcurl4-gnutls-dev,
+               libenca-dev,
+               libfaad-dev,
+               libflac-dev,
+               libgme-dev,
+               libjack-jackd2-dev,
+               libmad0-dev,
+               libmpcdec-dev,
+               libogg-dev,
+               libopus-dev,
+               libopusfile-dev,
+               liboss4-salsa-dev [!linux-any],
+               libpipewire-0.3-dev,
+               libprojectm-dev [!armel !armhf !hurd-any],
+               libpulse-dev,
+               libqt6opengl6-dev,
+               librcd-dev,
+               libshout-dev,
+               libsidplayfp-dev,
+               libsndfile1-dev,
+               libsoxr-dev,
+               libtag-dev,
+               libvorbis-dev,
+               libwavpack-dev,
+               libwildmidi-dev,
+               libx11-dev,
+               libxmp-dev,
+               pkgconf,
+               qt6-base-dev,
+               qt6-multimedia-dev,
+               qt6-tools-dev
+Standards-Version: 4.7.3
 Homepage: https://qmmp.ylsoftware.com/
 Vcs-Git: https://salsa.debian.org/debian/qmmp.git
 Vcs-Browser: https://salsa.debian.org/debian/qmmp
@@ -52,10 +53,10 @@
 Package: qmmp
 Architecture: any
 Depends: ${misc:Depends}, ${shlibs:Depends}
-Suggests: qmmp-plugin-projectm, ffmpeg, unzip, udisks2 [linux-any]
+Suggests: ffmpeg, qmmp-plugin-projectm, udisks2 [linux-any], unzip
 Recommends: freepats
-Replaces: libqmmp0 (<< 0.8), libqmmpui0 (<< 0.8), libqmmp-misc (<< 0.8)
-Breaks: libqmmp0 (<< 0.8), libqmmpui0 (<< 0.8), libqmmp-misc (<< 0.8)
+Replaces: libqmmp-misc (<< 0.8), libqmmp0 (<< 0.8), libqmmpui0 (<< 0.8)
+Breaks: libqmmp-misc (<< 0.8), libqmmp0 (<< 0.8), libqmmpui0 (<< 0.8)
 Description: feature-rich audio player with support of many formats
  Qmmp is feature-rich audio player with support of many formats.
  It is written in Qt.
@@ -124,8 +125,8 @@
   - media library
 
 Package: qmmp-plugin-projectm
-Architecture: any-amd64 any-arm64 i386 any-mips64el any-mipsel any-ppc64el any-s390x any-alpha any-hppa any-ia64 kfreebsd-any any-m68k any-powerpc any-ppc64 any-riscv64 any-sh4 any-sparc64 any-x32
-Depends: ${misc:Depends}, ${shlibs:Depends}, fonts-dejavu-core
+Architecture: any-alpha any-amd64 any-arm64 any-hppa any-ia64 any-m68k any-mips64el any-mipsel any-powerpc any-ppc64 any-ppc64el any-riscv64 any-s390x any-sh4 any-sparc64 any-x32 kfreebsd-any i386
+Depends: fonts-dejavu-core, ${misc:Depends}, ${shlibs:Depends}
 Description: qmmp audio player -- projectM visualization plugin
  Qmmp is feature-rich audio player with support of many formats.
  It is written in Qt.

=== debian/rules ===
--- 
+++ 
@@ -47,3 +47,8 @@
 	find -name '*.qm' | xargs rm -fv
 	rm -f debian/files
 	dh_auto_clean
+
+# No dbgsym packages:
+override_dh_strip:
+	@echo "NO--THANKS ANYWAY--but not building dbgsym packages for MX Linux"
+	dh_strip --no-automatic-dbgsym
